#ifndef SUMMECONCEPT_H
#define SUMMECONCEPT_H
#include <concepts>
#include <type_traits>                       // für std::is_arithmetic<T>

/*
template <typename T>
concept Zahl = requires(T w) {               // selbstgeschrieben
   w + w  ;
   w - w  ;                                  // nicht vollständig
};
*/

// Besser, weil Standard C++ und kürzer
template <typename T>
concept Zahl = std::is_arithmetic<T>::value; 

template <Zahl T> 
T summe(const std::vector<T>& vec)
{
  T ergebnis {0};
  for (auto summand : vec) {
    ergebnis += summand;
  }
  return ergebnis;
}
#endif
