#include <iostream>
#include <type_traits>
#include <vector>

class X {
};

int main()
{
  std::cout << std::boolalpha;
  std::cout << std::is_same_v<X, std::remove_reference_t<X&>> << '\n';          // true
  // std::remove_reference_t<X&> x; x ist vom Typ X

  std::cout << std::is_same_v<const int*, std::remove_const_t<const int*>>
            << '\n';          // true
  std::cout << std::is_same_v<const int*, std::remove_const_t<const int* const>>
            << '\n';          // true
  std::cout << std::is_same_v<int*, std::remove_const_t<int* const>>
            << '\n';          // true

  std::cout << std::is_same_v<int, std::decay_t<int&>> << '\n';               // true
  std::cout << std::is_same_v<int, std::decay_t<const int>> << '\n';          // true
  std::cout << std::is_same_v<X, std::decay_t<const X&>> << '\n';          // true
  std::cout << std::is_same_v<X*, std::decay<X[]>> << '\n';          // true
}
