#include <iostream>
#include <random>
#include <vector>

int main()
{
  std::mt19937 zufall;
  std::bernoulli_distribution verteilung(1.0 / 6.0);
  constexpr int iterationen{1000000};
  int anzahl_der_Sechsen{0};                 // oder Einsen, oder Zweien ...
  for (int i = 0; i < iterationen; ++i) {
    if (verteilung(zufall)) {                // 6 Augen?
      anzahl_der_Sechsen++;
    }
  }
  std::cout << "Bei " << iterationen << " Wuerfen wurde " << anzahl_der_Sechsen
            << " mal die 6 geworfen (" 
            << (100.0 * anzahl_der_Sechsen / iterationen) << " %).\n";
}
