#ifndef STUDENTIN_H
#define STUDENTIN_H
#include "Person.h"

class StudentIn : public Person {
public:
  StudentIn(const std::string& name, const std::string& vorname, const std::string& matnr)
      : Person{name, vorname}, matrikelnummer{matnr}
  {
  }
  const auto& getMatrikelnummer() const { return matrikelnummer; }
  virtual std::string toString() const override
  {
    return "Student/in " + Person::toString() + ", Mat.Nr.: " + matrikelnummer;
  }

private:
  std::string matrikelnummer;
};
#endif
