#include <iostream>
#include <type_traits>          // is_class usw.
#include <vector>

class Basis {
};

class Abgeleitet : public Basis {
};

int main()
{
  std::cout << std::boolalpha;
  std::cout << std::is_same_v<Basis, int> << '\n';                // false
  std::cout << std::is_same_v<Basis, Basis> << '\n';              // true
  std::cout << std::is_same_v<Abgeleitet, Basis> << "\n\n";       // false

  std::cout << std::is_base_of_v<Abgeleitet, Basis> << '\n';      // false
  std::cout << std::is_base_of_v<Basis, const Basis> << '\n';     // true
  std::cout << std::is_base_of_v<Basis, Abgeleitet> << "\n\n";    // true

  std::cout << std::is_convertible_v<Abgeleitet, Basis> << '\n';  // true
  std::cout << std::is_convertible_v<Basis, Abgeleitet> << '\n';  // false
  std::cout << std::is_convertible_v<int*, void*> << '\n';        // true
  std::cout << std::is_convertible_v<void*, int*> << '\n';        // false
}

