#include <chrono>
#include <functional>
#include <iostream>
#include <thread>

class Funktor {
public:
  void operator()()
  {
    // eigentliche Arbeit erledigen
    while(!ende) {
      if(istPause) {
        std::cout << "Pause!\n";
      }
      else {
        std::cout << ++zaehler << " Arbeit läuft ...\n";
      }
      std::this_thread::sleep_for(std::chrono::seconds(1));
    }
  }
 
  void pause()      { istPause = true; }
  void fortsetzen() { istPause = false; }
  void stop() { ende = true; }
private:
  int zaehler {0};
  bool istPause {false};
  bool ende {false};
};

using namespace std;

int main()
{
  Funktor f;
  jthread t(ref(f));                     // Ab hier wird operator()() ausgefuehrt.
  // Ohne ref() (d.h. jthread t(f);) sind die folgenden Aufrufe für f wirkungslos 
  cout << "main() wartet 4 s, dann Pause\n";
  this_thread::sleep_for(chrono::seconds(4));
  f.pause(); 
  cout << "main() wartet 4 s, dann Fortsetzen\n";
  this_thread::sleep_for(chrono::seconds(4));
  f.fortsetzen();
  cout << "main() wartet 4 s, dann Stop\n";
  this_thread::sleep_for(chrono::seconds(4));
  f.stop();
}
