#ifndef NAME_H
#define NAME_H
#include <iostream>
#include <string>

class Name {
public:
  Name(const std::string& str)
    : derName(str)
  { }

  Name(const Name& n)
    : derName(n.derName)
  {
    std::cout << "Name(const Name&)\n";
  }

  Name(Name&& n)
    : derName(std::move(n.derName))
  {
    std::cout << "Name(Name&&)\n";
  }

private:
  std::string derName;
};
#endif
