#include "Ressource.h"
#include <iostream>
#include <memory>
#include <vector>

int main()
{
  std::vector<std::shared_ptr<Ressource>> vps(10);
  // Initialisierung aller Elemente:
  for (int i = 0; i < std::ssize(vps); ++i) {
    vps[i] = std::make_shared<Ressource>(i);
    // statt vps[i] = std::shared_ptr<Ressource>(new Ressource(i));
  }
  // Benutzung:
  std::cout << "Werte:\n";
  for (auto ptr : vps) {
    ptr->hi();
  }
  std::cout << '\n';
}          // Destruktoren werden automatisch aufgerufen

